{% extends "wizard/base.html" %}
{% block title %}Step 5: Containers{% endblock %}
{% block step_content %}

<!-- Container deletion modal -->
  {% for container in wizard.app.container_set.all %}
    {% with application=wizard.app %}
      {% include "modals/container_delete.html" %}
    {% endwith %}
  {% endfor %}

  <div class="row">
    <div class="col-12">
      <h1 class="mt-5">Step 5: Containers</h1>
      <p>Let&apos;s create some containers for your app. Containers are what run your app. For example, if you have a Django application, you need a container to package the Django app up and expose its port for external requests. You can define one for multiple containers for an app. All containers are built from images that you pushed to your registry in the <a href="{% url 'wizard_view' step=4 %}">previous step</a>.</p>
      {% with application=wizard.app %}
        {% if not application.harborproject %}
          <div class="alert alert-warning no-harbor-project-warning-{{ application.identifier }}" role="alert">
            <h4 class="alert-heading">No image registry found</h4>
            <p class="mb-0">You need to have an image registry to create containers for this app. An image registry is where your containers are stored. Please click on the <strong>"Create project"</strong> button in the <strong>Image registry</strong> panel in the bottom right corner to create one right now! After that, you can start creating containers.</p>
          </div>
        {% endif %}
        {% if not application.port %}
          <div class="alert alert-warning no-harbor-project-warning-{{ application.identifier }}" role="alert">
            <h4 class="alert-heading">No main container found</h4>
            <p class="mb-0">You need exactly one main container to deploy the app. Click "edit" on one of the containers, check "Set this container as the main container" and submit.</p>
          </div>
        {% endif %}
        <div class="app-containers-display app-containers-display-{{ application.identifier }} {% if not application.harborproject %}d-none{% endif %}">
          <label class="app-container-btn create">+ Create a container</label>
          <div class="app-container create-form container-form">
            {% include "forms/config_container.html" %}
          </div>
          {% if application.container_set.count == 0 %}
            <p class="no-container-text text-center mt-5">No container found. Please create at least one container to start deploying app.</p>
          {% else %}
            <div class="app-containers-holder">
              {% for container in application.container_set.all %}
                {% if container.is_main %}
                  <p class="text-primary mt-4 mb-1">Primary container: This container port {{ container.port }} will be exposed for external traffic.</p>
                {% endif %}
                <div class="app-container {% if container.is_main %}border border-primary border-2{% endif %}" id="app-container-{{ container.id }}" data-scan-report-url="{% url 'scan_report_container' identifier=application.identifier container_id=container.id %}">
                        <!-- Container info -->
                  <div class="row mb-2">
                    <div class="col-4 fw-semibold">Image</div>
                    <div class="col-8 container-image">{{ container.image }}:{{ container.image_tag }}</div>
                  </div>
                  <div class="row mb-2">
                    <div class="col-4 fw-semibold">Exposed port</div>
                    <div class="col-8 container-port">{{ container.port }}</div>
                  </div>
                  <div class="row mb-2">
                    <div class="col-4 fw-semibold">Runtime command</div>
                    <div class="col-8 container-command">{{ container.command }}</div>
                  </div>
                  <div class="row">
                    <div class="col-4 fw-semibold">Environment variables</div>
                    {% load replace %}
                    <div class="col-8"><pre class="mt-1 container-environment-variables">{% if container.environment_variables %}{{ container.environment_variables|replace:"==|=" }}{% else %}None{% endif %}</pre></div>
                  </div>
                  <div class="app-modal-btn-container">
                    <button id="container-delete-modal-btn-{{ container.id }}" type="button" class="btn btn-outline-danger btn-sm delete-btn" data-bs-toggle="modal" data-bs-target="#containerDeleteModal-{{ container.id }}">Delete</button>
                    <button type="button" class="btn btn-outline-primary btn-sm edit-btn" data-container-id="{{ container.id }}">Edit</button>
                  </div>
                </div>
                <div class="app-container edit-form container-form {% if container.is_main %}border border-primary border-2{% endif %}" id="app-container-form-{{ container.id }}">
                  {% include "forms/config_container.html" %}
                </div>
              {% endfor %}
            </div>
          {% endif %}
        </div>
      {% endwith %}
    </div>

    <!-- Navigation buttons -->
    {% with is_form=False %}
      {% include 'wizard/navigation_btns.html' %}
    {% endwith %}
  </div>
{% endblock %}
